"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app = require("tns-core-modules/application");
var dialogs = require("tns-core-modules/ui/dialogs");
var grid_layout_1 = require("tns-core-modules/ui/layouts/grid-layout");
var stack_layout_1 = require("tns-core-modules/ui/layouts/stack-layout");
var label_1 = require("tns-core-modules/ui/label");
var scroll_view_1 = require("tns-core-modules/ui/scroll-view");
var grid_layout_2 = require("tns-core-modules/ui/layouts/grid-layout");
var text_field_1 = require("tns-core-modules/ui/text-field");
var button_1 = require("tns-core-modules/ui/button");
var repeater_1 = require("tns-core-modules/ui/repeater");
var activity_indicator_1 = require("tns-core-modules/ui/activity-indicator");
var observable_array_1 = require("tns-core-modules/data/observable-array");
var text_view_1 = require("tns-core-modules/ui/text-view");
var platform_1 = require("tns-core-modules/platform");
var Common = (function (_super) {
    __extends(Common, _super);
    function Common() {
        var _this = _super.call(this) || this;
        _this._newComment = "";
        _this.textReplyToHolder = "";
        _this.toText = "Repling to :";
        _this.xbtn = "x";
        _this.fontClass = "fa";
        _this.editing = 0;
        _this.replyTo = 0;
        _this.editingText = "Editing your comment";
        _this.scroll = true;
        _this.initscroll = true;
        _this.title = "Comments";
        _this.replyText = "Reply";
        _this.likeText = "like";
        _this.sendText = "Comment";
        _this.likeQ = [];
        _this.isadmin = false;
        _this.canComment = true;
        _this.textview = false;
        var self = _this;
        setTimeout(function () {
            _this.init();
        }, 100);
        var resorce = app.getResources();
        resorce["getlikeText"] = function (likes) {
            return self.likeText + " (" + likes + ")";
        };
        resorce["commentsDateTo"] = function (time) {
            switch (typeof time) {
                case "number":
                    break;
                case "string":
                    time = +new Date(time);
                    break;
                case "object":
                    if (time.constructor === Date)
                        time = time.getTime();
                    break;
                default:
                    time = +new Date();
            }
            var time_formats = [
                [60, "seconds", 1],
                [120, "1 minute ago", "1 minute from now"],
                [3600, "minutes", 60],
                [7200, "1 hour ago", "1 hour from now"],
                [86400, "hours", 3600],
                [172800, "Yesterday", "Tomorrow"],
                [604800, "days", 86400],
                [1209600, "Last week", "Next week"],
                [2419200, "weeks", 604800],
                [4838400, "Last month", "Next month"],
                [29030400, "months", 2419200],
                [58060800, "Last year", "Next year"],
                [2903040000, "years", 29030400],
                [5806080000, "Last century", "Next century"],
                [58060800000, "centuries", 2903040000]
            ];
            var seconds = (+new Date() - time) / 1000, token = "ago", list_choice = 1;
            if (seconds === 0) {
                return "Just now";
            }
            if (seconds < 0) {
                seconds = Math.abs(seconds);
                token = "from now";
                list_choice = 2;
            }
            var i = 0, format;
            while ((format = time_formats[i++]))
                if (seconds < format[0]) {
                    if (typeof format[2] === "string")
                        return format[list_choice];
                    else
                        return (Math.floor(seconds / format[2]) + " " + format[1] + " " + token);
                }
            return time;
        };
        app.setResources(resorce);
        return _this;
    }
    Common.prototype.random = function (range) {
        return Math.floor(Math.random() * range + 1);
    };
    Common.prototype.baseTemplate = function (canComment, plugin, imageholder, commentsDateTo) {
        if (canComment)
            return "\n        <GridLayout dataediting=\"{{ editing,editing }}\" dataid=\"{{ id }}\" datacomment=\"{{ comment }}\" longPress=\"{{$parents['Repeater'].LongPress,$parents['Repeater'].LongPress}}\"  " + plugin + " class=\"{{ 'comment' + (replyTo ? ' comment-reply' : '') + (isOwn ? ' own' : '') }}\" rows=\"auto\" columns=\"auto,*\">\n        <StackLayout dataid=\"{{ id }}\" tap=\"{{$parents['Repeater'].userImageAction,$parents['Repeater'].userImageAction}}\"  verticalAlignment=\"top\" row=\"0\" col=\"0\">\n        " + imageholder + "\n        </StackLayout>\n        <GridLayout row=\"0\" col=\"1\" rows=\"auto,auto,auto,auto\">\n          <Label row=\"0\" col=\"1\" dataid=\"{{ id }}\" tap=\"{{$parents['Repeater'].userNameAction,$parents['Repeater'].userNameAction}}\" text=\"{{ username }}\" class=\"comment-username\" textWrap=\"true\" />\n          <Label row=\"1\" col=\"1\" class=\"comment-text\" text=\"{{ comment }}\" textWrap=\"true\" />\n          <StackLayout class=\"comment-action-bar\" row=\"2\" orientation=\"horizontal\">\n            <Label text=\"{{ getlikeText(likes) }}\"  dataid=\"{{ id }}\"  tap=\"{{$parents['Repeater'].likeAction,$parents['Repeater'].likeAction}}\" isLike=\"{{ isLike }}\" likes=\"{{ likes }}\"  class=\"{{ isLike ? 'comment-action like liked' : 'comment-action like'}}\" textWrap=\"true\" />\n            <Label  visibility=\"{{ replyTo  ? 'collapse' : 'visible'}}\"  text=\".\" class=\"comment-separator\" />\n            <Label visibility=\"{{ replyTo  ? 'collapse' : 'visible'}}\"  dataid=\"{{ id }}\" dataname=\"{{ username }}\" text=\"{{$parents['Repeater'].replyText,$parents['Repeater'].replyText}}\" tap=\"{{$parents['Repeater'].replyAction,$parents['Repeater'].replyAction}}\" class=\"comment-action reply\" textWrap=\"true\" />\n            <Label  id=\"{{ id }}\" text=\"{{ " + commentsDateTo + "(datetime) }}\" class=\"comment-details\" textWrap=\"true\" />\n          </StackLayout>\n          <StackLayout row=\"3\"  id=\"{{ scrolltome ? scrolltome : ''  }}\" />\n         </GridLayout>\n        </GridLayout>\n        ";
        else
            return "\n        <GridLayout dataediting=\"{{ editing,editing }}\" dataid=\"{{ id }}\" datacomment=\"{{ comment }}\" longPress=\"{{$parents['Repeater'].LongPress,$parents['Repeater'].LongPress}}\"  " + plugin + " class=\"{{ 'comment' + (replyTo ? ' comment-reply' : '') + (isOwn ? ' own' : '') }}\" rows=\"auto\" columns=\"auto,*\">\n        <StackLayout dataid=\"{{ id }}\" tap=\"{{$parents['Repeater'].userImageAction,$parents['Repeater'].userImageAction}}\"  verticalAlignment=\"top\" row=\"0\" col=\"0\">\n        " + imageholder + "\n        </StackLayout>\n        <GridLayout row=\"0\" col=\"1\" rows=\"auto,auto,auto,auto\">\n          <Label row=\"0\" col=\"1\" dataid=\"{{ id }}\" tap=\"{{$parents['Repeater'].userNameAction,$parents['Repeater'].userNameAction}}\" text=\"{{ username }}\" class=\"comment-username\" textWrap=\"true\" />\n          <Label row=\"1\" col=\"1\" class=\"comment-text\" text=\"{{ comment }}\" textWrap=\"true\" />\n          <StackLayout class=\"comment-action-bar\" row=\"2\" orientation=\"horizontal\">\n            <Label  id=\"{{ id }}\" text=\"{{ " + commentsDateTo + "(datetime) }}\" class=\"comment-details\" textWrap=\"true\" />\n          </StackLayout>\n          <StackLayout row=\"3\"  id=\"{{ scrolltome ? scrolltome : ''  }}\" />\n         </GridLayout>\n        </GridLayout>\n        ";
    };
    Object.defineProperty(Common.prototype, "newComment", {
        get: function () {
            return this._newComment;
        },
        set: function (value) {
            this._newComment = value;
        },
        enumerable: true,
        configurable: true
    });
    Common.prototype.adjustTextHeight = function (textview, value) {
        var linesCount = 0;
        var self = this;
        if (platform_1.isIOS) {
            linesCount =
                textview.ios.contentSize.height / textview.ios.font.lineHeight;
            if (linesCount <= 5) {
                textview.height = textview.ios.contentSize.height + 10;
            }
        }
        else {
            linesCount = textview.android.getLineCount();
            var lineHieght = 20;
            if (linesCount <= 5) {
                var height_in_pixels = linesCount * lineHieght;
                textview.height = height_in_pixels;
            }
            else {
                var height_in_pixels = 5 * lineHieght;
                textview.height = height_in_pixels;
            }
        }
    };
    Common.prototype.replyAction = function (args) {
        var self = args.object.parent.parent.parent.parent.bindingContext;
        var obj = args.object;
        self.editing = 0;
        self.replyingto.text = self.toText;
        self.replytoWraper.visibility = "visible";
        self.replyTo = obj.get("dataid");
        self.textReplyToHolder.text = obj.get("dataname");
        self.textField.focus();
    };
    Common.prototype.userNameAction = function (args) {
        var self = args.object.parent.parent.parent.bindingContext;
        var obj = args.object;
        self.userAction(obj.get("dataid"));
    };
    Common.prototype.userImageAction = function (args) {
        var self = args.object.parent.parent.bindingContext;
        var obj = args.object;
        self.userAction(obj.get("dataid"));
    };
    Common.prototype.userAction = function (id) {
        var self = this;
        var index;
        index = self.items.filter(function (item) {
            return item.id == id;
        });
        index = self.items.indexOf(index[0]);
        self.notify({
            eventName: Common.userEvent,
            object: self,
            comment: self.items.getItem(index)
        });
    };
    Common.prototype.likeAction = function (args) {
        var obj = args.object;
        var self = args.object.parent.parent.parent.parent.bindingContext;
        self.likeQ[obj.get("dataid")] = { obj: obj, self: self };
        obj.className = "comment-action like loading";
        self.notify({
            eventName: Common.likeEvent,
            object: self,
            to: obj.get("dataid")
        });
    };
    Common.prototype.LongPress = function (args) {
        var obj = args.object;
        var self = args.object.parent.bindingContext;
        if (obj.get("dataediting") == true) {
            dialogs
                .action("What to do ?", "Cancel", ["Delete", "Edit"])
                .then(function (result) {
                if (result == "Delete") {
                    self.delete(obj.get("dataid"));
                }
                else if (result == "Edit") {
                    self.edit(obj.get("dataid"), obj.get("datacomment"));
                }
            });
        }
        else if (self.isadmin == true) {
            dialogs
                .action("What to do ?", "Cancel", ["Delete"])
                .then(function (result) {
                if (result == "Delete") {
                    self.delete(obj.get("dataid"));
                }
            });
        }
    };
    Common.prototype.edit = function (id, comment) {
        this.replyingto.text = this.editingText;
        this.textReplyToHolder.text = "";
        this.replytoWraper.visibility = "visible";
        this.editing = id;
        this.textField.text = comment;
        this.textField.focus();
    };
    Common.prototype.delete = function (id) {
        var self = this;
        dialogs.confirm("Are you sure ?").then(function (result) {
            if (result) {
                self.items.forEach(function (element) {
                    if (element.id == id || element.replyTo == id) {
                        var index_1 = self.items.indexOf(element);
                        self.items.splice(index_1, 1);
                    }
                });
                self.notify({
                    eventName: Common.deleteEvent,
                    object: self,
                    id: id
                });
                self.refresh();
            }
        });
    };
    Common.prototype.toggle = function (to) {
        if (this.likeQ[to]) {
            var obj = this.likeQ[to].obj;
            var self_1 = this.likeQ[to].self;
            if (!obj.isLike) {
                obj.likes = obj.likes + 1;
                obj.isLike = true;
                obj.className = "comment-action like liked";
            }
            else {
                obj.likes = obj.likes - 1;
                obj.isLike = false;
                obj.className = "comment-action like";
            }
            obj.text = self_1.likeText + " (" + obj.likes + ")";
            var index_2 = self_1.items.filter(function (item) {
                return item.id === to;
            });
            index_2 = self_1.items.indexOf(index_2[0]);
            self_1.items.getItem(index_2).likes = obj.likes;
            self_1.items.getItem(index_2).isLike = obj.isLike;
        }
    };
    Common.prototype.process = function () {
        var replys = this.items.filter(function (item) {
            return item.replyTo;
        });
        var comments = this.items.filter(function (item) {
            return !item.replyTo;
        });
        var commentsandReplys = [];
        comments.forEach(function (element) {
            commentsandReplys.push(element);
            replys.forEach(function (elementreply) {
                if (element.id == elementreply.replyTo)
                    commentsandReplys.push(elementreply);
            });
        });
        return commentsandReplys;
    };
    Common.prototype.commentCount = function () {
        var count = this.items.length;
        return this.title + " (" + count + ")";
    };
    Common.prototype.init = function () {
        var _this = this;
        var self = this;
        if (this.scroll === "false")
            this.scroll = false;
        else
            this.scroll = true;
        if (this.canComment === "false")
            this.canComment = false;
        else if (this.canComment === "true")
            this.canComment = true;
        if (this.textview === "false")
            this.textview = false;
        else if (this.textview === "true")
            this.textview = true;
        if (self.isadmin == "true")
            self.isadmin = true;
        else if (self.isadmin == "false")
            self.isadmin = false;
        var hrlight = this.parseOptions(new stack_layout_1.StackLayout(), {
            className: "hr-light"
        });
        this.headtitle = this.parseOptions(new label_1.Label(), {
            class: "comment-title",
            text: this.commentCount()
        });
        this.addChild(this.headtitle);
        this.addChild(hrlight);
        if (Object.prototype.toString.call(this.items) == "[object Array]")
            this.items = new observable_array_1.ObservableArray(this.items);
        var wraper = this.parseOptions(new grid_layout_1.GridLayout(), {
            rows: ["star", "auto", "auto"]
        });
        var imageholder = "";
        if (this.imagetag)
            imageholder = this.imagetag;
        else
            imageholder =
                '<Image  src="{{ image }}" class="comment-userimage img-circle" height="45" width="45" stretch="fill" />';
        var plugin = "";
        if (this.plugin)
            plugin = this.plugin;
        if (this.scroll === true)
            this.scrollview = this.parseOptions(new scroll_view_1.ScrollView(), {
                row: 0
            });
        else
            this.scrollview = this.parseOptions(new stack_layout_1.StackLayout(), {
                row: 0
            });
        this.rep = new repeater_1.Repeater();
        if (this.items[this.items.length - 1])
            this.items[this.items.length - 1].scrolltome = "scrolltome";
        this.rep.items = this.process();
        this.rep.bindingContext = self;
        this.rep.id = "mainrep";
        var commentsDateTo;
        if (this.dateHandler)
            commentsDateTo = this.dateHandler;
        else
            commentsDateTo = "commentsDateTo";
        if (typeof this.customTemplate != "function") {
            this.customTemplate = this.baseTemplate;
        }
        this.rep.itemTemplate = this.customTemplate(this.canComment, plugin, imageholder, commentsDateTo);
        if (this.scroll === true)
            this.scrollview.content = this.rep;
        else
            this.scrollview.addChild(this.rep);
        this.replytoWraper = this.parseOptions(new grid_layout_1.GridLayout(), {
            row: 1,
            class: "comment-reply-wrapper",
            width: "100%",
            visibility: "collapse",
            columns: ["auto", "auto", "star"]
        });
        var footer = this.parseOptions(new grid_layout_1.GridLayout(), {
            className: "comment-footer",
            row: 2,
            rows: ["auto"],
            columns: ["star", "auto"]
        });
        var xbtn = this.parseOptions(new label_1.Label(), {
            className: "comment-reply-x-btn fa",
            row: 0,
            col: 0,
            text: this.xbtn
        });
        this.replyingto = this.parseOptions(new label_1.Label(), {
            className: "comment-replyingto",
            text: this.toText,
            row: 0,
            col: 1,
        });
        this.textReplyToHolder = this.parseOptions(new label_1.Label(), {
            className: "comment-reply-username",
            text: this.replyTo,
            row: 1,
            col: 2,
        });
        this.replytoWraper.addChild(xbtn);
        this.replytoWraper.addChild(this.replyingto);
        this.replytoWraper.addChild(this.textReplyToHolder);
        xbtn.on("tap", function () {
            self.replytoWraper.visibility = "collapse";
            self.replyTo = 0;
            self.editing = 0;
        });
        if (this.textview) {
            this.textField = this.parseOptions(new text_view_1.TextView(), {
                className: "comment-field comment-textview",
                id: "comment-field",
                row: 2,
                col: 0,
                editable: true,
                hint: "Comment..."
            });
            this.textField.on("textChange", function (a) {
                if (!!a.value.length && a.value[a.value.length - 1] === "@") {
                    _this.notify({
                        eventName: Common.mentionEvent,
                        object: a.object,
                        value: a.value
                    });
                }
            });
        }
        else {
            this.textField = this.parseOptions(new text_field_1.TextField(), {
                className: "comment-field",
                id: "comment-field",
                row: 2,
                col: 0,
                hint: "Comment..."
            });
            this.textField.on("textChange", function (a) {
                if (!!a.value.length && a.value[a.value.length - 1] === "@") {
                    _this.notify({
                        eventName: Common.mentionEvent,
                        object: a.object,
                        value: a.value
                    });
                }
            });
        }
        this.sendbtn = this.parseOptions(new button_1.Button(), {
            className: "comment-btn " + this.fontClass,
            row: 1,
            col: 1,
            text: this.sendText
        });
        var textFieldBindingOptions = {
            sourceProperty: "newComment",
            targetProperty: "text",
            twoWay: true
        };
        this.textField.bind(textFieldBindingOptions, self);
        this.sendbtn.on("tap", function () {
            if (!_this.activityindecator.busy) {
                if (self.editing != 0) {
                    self.notify({
                        eventName: Common.editEvent,
                        object: self,
                        comment: self.newComment,
                        id: self.editing,
                        to: self.replyTo
                    });
                    var toedit = self.items.filter(function (elemet) {
                        return elemet.id == self.editing;
                    });
                    self.items.getItem(self.items.indexOf(toedit[0])).comment =
                        self.newComment;
                    _this.replytoWraper.visibility = "collapse";
                    _this.editing = 0;
                    _this.textField.text = "";
                    self.refresh();
                }
                else
                    self.notify({
                        eventName: Common.addEvent,
                        object: self,
                        comment: self.newComment,
                        to: self.replyTo
                    });
            }
        });
        footer.addChild(this.textField);
        footer.addChild(this.sendbtn);
        this.activityindecator = this.parseOptions(new activity_indicator_1.ActivityIndicator(), {
            className: "comment-indicator",
            horizontalAlignment: "center",
            verticalAlignment: "middle",
            row: 2,
            col: 1
        });
        footer.addChild(this.activityindecator);
        wraper.addChild(this.scrollview);
        wraper.addChild(this.replytoWraper);
        if (this.canComment) {
            wraper.addChild(footer);
        }
        this.addChild(wraper);
        this.addChild(this.parseOptions(new stack_layout_1.StackLayout(), { id: "comments-understack" }));
    };
    Common.prototype.busy = function (flag) {
        if (flag) {
            this.activityindecator.busy = true;
            this.sendbtn.className = "comment-btn loading " + this.fontClass;
        }
        else {
            this.activityindecator.busy = false;
            this.sendbtn.className = "comment-btn " + this.fontClass;
        }
    };
    Common.prototype.push = function (obj) {
        var _this = this;
        var self = this;
        var scrolltome = this.rep.getViewById("scrolltome");
        if (scrolltome)
            scrolltome.id = "";
        self.items.forEach(function (item) {
            delete item.scrolltome;
        });
        obj["scrolltome"] = "scrolltome";
        self.items.push(obj);
        this.refresh();
        setTimeout(function () {
            if (_this.scroll === true) {
                var scrolltome_1 = _this.rep.getViewById("scrolltome");
                if (self.initscroll && _this.scrollview.scrollableHeight) {
                    _this.scrollview.scrollToVerticalOffset(_this.scrollview.scrollableHeight, false);
                    self.initscroll = false;
                }
                if (scrolltome_1)
                    _this.scrollview.scrollToVerticalOffset(scrolltome_1.getLocationRelativeTo(self).y, true);
            }
        }, 100);
        self.textField.text = "";
        self.headtitle.text = self.commentCount();
    };
    Common.prototype.refresh = function () {
        this.headtitle.text = this.commentCount();
        this.rep.items = this.process();
        this.rep.refresh();
        this.rep.className = "comments-repeater";
    };
    Common.prototype.parseOptions = function (view, options) {
        Object.keys(options).forEach(function (key, index) {
            if (key === "rows")
                options[key].forEach(function (value, index) {
                    view.addRow(new grid_layout_2.ItemSpec(1, value));
                });
            else if (key === "columns")
                options[key].forEach(function (value, index) {
                    view.addColumn(new grid_layout_2.ItemSpec(1, value));
                });
            else {
                view[key] = options[key];
            }
        });
        return view;
    };
    return Common;
}(stack_layout_1.StackLayout));
Common.likeEvent = "like";
Common.deleteEvent = "delete";
Common.editEvent = "edit";
Common.addEvent = "add";
Common.userEvent = "user";
Common.mentionEvent = "mention";
exports.Common = Common;
//# sourceMappingURL=comments.common.js.map